from gi.repository import Nautilus, GObject
import os
import subprocess
import urllib

class CrunchyExtractTo(GObject.GObject, Nautilus.MenuProvider):
    def __init__(self):
        pass

    def url2path(self,url):
        fileuri= url.get_activation_uri()
        arg_uri=fileuri[7:]
        path=urllib.url2pathname(arg_uri)
        return path

    def extract_to(self,menu,files):
        for file in files:
            cmd=['crunchy-gtk']
            filepath=self.url2path(files[0])
            cmd.append("--extract-ask")
            cmd.append(filepath)
            subprocess.Popen(cmd)
            break
        return

    def is_files(self,files):
        for file in files:
            mime=file.get_mime_type()
            if mime == 'inode/directory':
                return False
        return True
    
    def get_file_items(self, window, files):
        filecount=len(files)
        if filecount <= 0:
            return 

        if self.is_files(files) == True :
            # extract to
            menu_item = Nautilus.MenuItem(name='CrunchyExtractToMenuItem::CrunchyExtractTo', 
                                        label='Extract To...', 
                                        tip='Extract files to specified location'
                                        )
            menu_item.connect('activate',self.extract_to,files)
            return [menu_item]
        else:
            return
